#This should count the cofires and nonCofires of neurons.
#It works on one input file and returns the two matrices (coFire,nonCofire)
#Cofiring is at the same time or with the postSynaptic neuron firing after
#but with the preTime + coFireWindow.
#It also counts correlations, and generates weights.

#tests are pretty weak

import sys
import cPickle as pickle
import numpy as np

class CountCoFireClass:
    coFireWindow = 10.0

    def getSpikes(self, fileName):
        fileHandle = open(fileName)
        neoObj = pickle.load(fileHandle)
        segments = neoObj.segments
        segment = segments[0]
        spikeTrains = segment.spiketrains
        fileHandle.close()
        return spikeTrains

    #loop through each preSpike
    def getCoFiring(self,preSpikes,postSpikes):
        if (len(postSpikes) == 0):
            return (0,len(preSpikes))
        cofires = 0
        noCofires = 0
        postSpikeNum = 0
        for preSpikeNum in range (0,len(preSpikes)):
            preSpikeTime = float(preSpikes[preSpikeNum])
            if (postSpikeNum >= len(postSpikes)):
                postSpikeTime = float("inf")
            else:
                postSpikeTime = float(postSpikes[postSpikeNum])
            #ignore postSpikes between the last and this preSpike
            while postSpikeTime < preSpikeTime:
                postSpikeNum = postSpikeNum + 1
                if (postSpikeNum >= len(postSpikes)):
                    postSpikeTime = float("inf")
                else:
                    postSpikeTime = float(postSpikes[postSpikeNum])

            if (postSpikeTime <= (preSpikeTime + self.coFireWindow)):
                cofires = cofires + 1
            else:
                noCofires = noCofires + 1
        
        return [cofires,noCofires]

    def countPreCorr(self,spikeTrains):
        coAndNoFires = self.countPreCorrSameNet(spikeTrains)
        return coAndNoFires
        
    def countPreCorrSameNet(self,spikeTrains):
        numNeurons = len(spikeTrains)
        coFires = np.zeros((numNeurons,numNeurons),dtype='i')
        noPostFires = np.zeros((numNeurons,numNeurons),dtype='i')
        for preNeuron in range (0,numNeurons):
            for postNeuron in range (0,numNeurons):
                #print preNeuron, postNeuron
                if (preNeuron == postNeuron):
                    coFires[preNeuron,postNeuron] = -1
                    noPostFires[preNeuron,postNeuron] = -1
                else:
                    preSpikes = spikeTrains[preNeuron]
                    postSpikes = spikeTrains[postNeuron]
                    coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                    coFires[preNeuron,postNeuron] = coAndNotCoFires[0]
                    noPostFires[preNeuron,postNeuron] = coAndNotCoFires[1]

        return [coFires,noPostFires]


    def countPreCorrTwoNets(self,spikeTrainsA,spikeTrainsB):
        numANeurons = len(spikeTrainsA)
        numBNeurons = len(spikeTrainsB)

        coFiresAB = np.zeros((numANeurons,numBNeurons),dtype='i')
        noPostFiresAB = np.zeros((numANeurons,numBNeurons),dtype='i')
        #from A
        for preNeuron in range (0,numANeurons):
            #from A to B
            for postNeuron in range (0,numBNeurons):
                preSpikes = spikeTrainsA[preNeuron]
                postSpikes = spikeTrainsB[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresAB[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresAB[preNeuron,postNeuron] = coAndNotCoFires[1]

        coFiresBA = np.zeros((numBNeurons,numANeurons),dtype='i')
        noPostFiresBA = np.zeros((numBNeurons,numANeurons),dtype='i')
        #from B
        for preNeuron in range (0,numBNeurons):
            #from B to A
            for postNeuron in range (0,numANeurons):
                preSpikes = spikeTrainsB[preNeuron]
                postSpikes = spikeTrainsA[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresBA[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresBA[preNeuron,postNeuron] = coAndNotCoFires[1]

        return [coFiresAB,noPostFiresAB,coFiresBA,noPostFiresBA]


    def countPreCorrThreeNets(self,spikeTrainsA,spikeTrainsB,spikeTrainsC):
        numANeurons = len(spikeTrainsA)
        numBNeurons = len(spikeTrainsB)
        numCNeurons = len(spikeTrainsC)

        coFiresAB = np.zeros((numANeurons,numBNeurons),dtype='i')
        noPostFiresAB = np.zeros((numANeurons,numBNeurons),dtype='i')
        coFiresAC = np.zeros((numANeurons,numCNeurons),dtype='i')
        noPostFiresAC = np.zeros((numANeurons,numCNeurons),dtype='i')
        #from A
        for preNeuron in range (0,numANeurons):
            #from A to B
            for postNeuron in range (0,numBNeurons):
                preSpikes = spikeTrainsA[preNeuron]
                postSpikes = spikeTrainsB[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresAB[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresAB[preNeuron,postNeuron] = coAndNotCoFires[1]

            #from A to C
            for postNeuron in range (0,numCNeurons):
                preSpikes = spikeTrainsA[preNeuron]
                postSpikes = spikeTrainsC[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresAC[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresAC[preNeuron,postNeuron] = coAndNotCoFires[1]

        coFiresBA = np.zeros((numBNeurons,numANeurons),dtype='i')
        noPostFiresBA = np.zeros((numBNeurons,numANeurons),dtype='i')
        coFiresBC = np.zeros((numBNeurons,numCNeurons),dtype='i')
        noPostFiresBC = np.zeros((numBNeurons,numCNeurons),dtype='i')
        #from B
        for preNeuron in range (0,numBNeurons):
            #from B to A
            for postNeuron in range (0,numANeurons):
                preSpikes = spikeTrainsB[preNeuron]
                postSpikes = spikeTrainsA[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresBA[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresBA[preNeuron,postNeuron] = coAndNotCoFires[1]
            #from B to C
            for postNeuron in range (0,numCNeurons):
                preSpikes = spikeTrainsB[preNeuron]
                postSpikes = spikeTrainsC[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresBC[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresBC[preNeuron,postNeuron] = coAndNotCoFires[1]

        coFiresCA = np.zeros((numCNeurons,numANeurons),dtype='i')
        noPostFiresCA = np.zeros((numCNeurons,numANeurons),dtype='i')
        coFiresCB = np.zeros((numCNeurons,numBNeurons),dtype='i')
        noPostFiresCB = np.zeros((numCNeurons,numBNeurons),dtype='i')
        #from C
        for preNeuron in range (0,numCNeurons):
            #from C to A
            for postNeuron in range (0,numANeurons):
                preSpikes = spikeTrainsC[preNeuron]
                postSpikes = spikeTrainsA[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresCA[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresCA[preNeuron,postNeuron] = coAndNotCoFires[1]
            #from C to B
            for postNeuron in range (0,numBNeurons):
                preSpikes = spikeTrainsC[preNeuron]
                postSpikes = spikeTrainsB[postNeuron]
                coAndNotCoFires = self.getCoFiring(preSpikes,postSpikes)
                coFiresCB[preNeuron,postNeuron] = coAndNotCoFires[0]
                noPostFiresCB[preNeuron,postNeuron] = coAndNotCoFires[1]

        return [coFiresAB,noPostFiresAB,coFiresAC,noPostFiresAC,
                coFiresBA,noPostFiresBA,coFiresBC,noPostFiresBC,
                coFiresCA,noPostFiresCA,coFiresCB,noPostFiresCB]

###
    def calculateCorrelation(self,coFires,noFires,numPreNeurons,numPostNeurons):
        correlation = np.zeros((numPreNeurons,numPostNeurons),dtype='f')
        for preNeuron in range (0,numPreNeurons):
            for postNeuron in range (0,numPostNeurons):
                total = coFires[preNeuron,postNeuron]+noFires[preNeuron,
                                                              postNeuron]
                #print coFires[preNeuron,postNeuron]
                if (total == 0) or (coFires[preNeuron,postNeuron] == 0):
                    correlation[preNeuron,postNeuron] = 0.0
                else:
                    correlation[preNeuron,postNeuron] = coFires[preNeuron,
                                                postNeuron]/float( total)
        return correlation

    ###Calculate Wts

    #given the correlations from a net to two others, calculate the weights and
    #return them
    def calculateNewPreWtsFromToTwo(self,toNetACorrelations,
                            toNetBCorrelations,goalWt):
        numFromNeurons = len(toNetACorrelations)
        numToANeurons = len(toNetACorrelations[0])
        numToBNeurons = len(toNetBCorrelations[0])
        newToAWts = np.zeros((numFromNeurons,numToANeurons),dtype='f')
        newToBWts = np.zeros((numFromNeurons,numToBNeurons),dtype='f')
        for preNeuron in range (0,numFromNeurons):
            totalCorrelation = 0.0  #this can be greater than 1
                
            #next the other to nets
            for postNeuron in range (0,numToANeurons):
                totalCorrelation += toNetACorrelations[preNeuron,postNeuron] 
            for postNeuron in range (0,numToBNeurons):
                totalCorrelation += toNetBCorrelations[preNeuron,postNeuron] 

            preCorrMod = 0.0
            if (totalCorrelation > 0):
                preCorrMod = goalWt/totalCorrelation

            for postNeuron in range (0,numToANeurons):
                newWt = toNetACorrelations[preNeuron,postNeuron] *preCorrMod
                newToAWts [preNeuron,postNeuron]  =  newWt 

            for postNeuron in range (0,numToBNeurons):
                newWt = toNetBCorrelations[preNeuron,postNeuron] *preCorrMod
                newToBWts [preNeuron,postNeuron]  =  newWt 

        return [newToAWts,newToBWts]


    #This takes the correlations from three nets, the first within the from
    #net, the second and third the correlations from the from to the two post nets.
    #It returns the three sets of weights, within the from net, and the
    #weights from the from net to the other to nets
    def calculateNewPreThreeWts(fromNetCorrelations,toNetACorrelations,
                            toNetBCorrelations,goalWt):
        numFromNeurons = len(fromNetCorrelations)
        numToANeurons = len(toNetACorrelations[0])
        numToBNeurons = len(toNetBCorrelations[0])
        newFromWts = np.zeros((numFromNeurons,numFromNeurons),dtype='f')
        newToAWts = np.zeros((numFromNeurons,numToANeurons),dtype='f')
        newToBWts = np.zeros((numFromNeurons,numToBNeurons),dtype='f')
        for preNeuron in range (0,numFromNeurons):
            totalCorrelation = 0.0  #this can be greater than 1
            #calculate total correlations from this neuron, first in the from net
            for postNeuron in range (0,numFromNeurons):
                if (preNeuron != postNeuron):
                    totalCorrelation += fromNetCorrelations[preNeuron,postNeuron] 
                
            #next the other to nets
            for postNeuron in range (0,numToANeurons):
                totalCorrelation += toNetACorrelations[preNeuron,postNeuron] 
            for postNeuron in range (0,numToBNeurons):
                totalCorrelation += toNetBCorrelations[preNeuron,postNeuron] 

            preCorrMod = 0.0
            if (totalCorrelation > 0):
                preCorrMod = goalWt/totalCorrelation

            for postNeuron in range (0,numFromNeurons):
                if (preNeuron != postNeuron):
                    newWt = fromNetCorrelations[preNeuron,postNeuron] *preCorrMod
                else:
                    newWt = 0.0
                newFromWts [preNeuron,postNeuron]  =  newWt 

            for postNeuron in range (0,numToANeurons):
                newWt = toNetACorrelations[preNeuron,postNeuron] *preCorrMod
                newToAWts [preNeuron,postNeuron]  =  newWt 

            for postNeuron in range (0,numToBNeurons):
                newWt = toNetBCorrelations[preNeuron,postNeuron] *preCorrMod
                newToBWts [preNeuron,postNeuron]  =  newWt 

            return [newFromWts,newToAWts,newToBWts]

    #calculate the weights from one net to another based on correlations
    #and the goal weight.  This is the preCompensatory rule
    def calculateNewAToBWts(self,fromToCorrelations,numFromNeurons,numToNeurons,
                            goalWt):

        #set up the blank well connected matrices
        newAToBWts = np.zeros((numFromNeurons,numToNeurons),dtype='f')

        for preNeuron in range (0,numFromNeurons):
            #set up the total correlation from this neuron
            totalCorrelation = 0.0  #this can be greater than 1

            #calculate total correlations from this neuron, to both nets
            for postNeuron in range (0,numToNeurons):
                totalCorrelation+=fromToCorrelations[preNeuron,postNeuron] 
        
            #get this preNeurons correlation modifier
            preCorrMod = 0.0
            if (totalCorrelation > 0):
                preCorrMod = goalWt/totalCorrelation

            #Calculate the weights 
            for postNeuron in range (0,numToNeurons):
                newWt = fromToCorrelations[preNeuron,postNeuron]*preCorrMod
                newAToBWts [preNeuron,postNeuron]  =  newWt 

        return newAToBWts

    #Calculate the postCompensatory weights from one net to another based 
    #on correlations and the goal weight.  
    def calculateNewPostAToBWts(self,fromToCorrelations,numFromNeurons,
                                numToNeurons, goalWt):
        #setup well connected blank matrix
        newFromToWts = np.zeros((numFromNeurons,numToNeurons),dtype='f')

        for postNeuron in range (0,numToNeurons):
            totalCorrelation = 0.0  #this can be greater than 1
            #calculate total correlations to this neuron
            for preNeuron in range (0,numFromNeurons):
                totalCorrelation+=fromToCorrelations[preNeuron,postNeuron] 

            #get this postNeurons correlation modifier
            postCorrMod = 0.0
            if (totalCorrelation > 0):
                postCorrMod = goalWt/totalCorrelation

            #Calculate the weights from semantics
            for preNeuron in range (0,numFromNeurons):
                newWt = (fromToCorrelations[preNeuron,postNeuron]*
                         postCorrMod)
                newFromToWts [preNeuron,postNeuron]  =  newWt 

        return newFromToWts


    #Here we have three nets, the coffee, coke and semantic nets.
    #Calculate the new wts coffee <-> sem and coke <-> sem.
    #Coffee and coke -> sem uses a precompensatory rule
    #sem -> coffee and coke uses a postcompensatory rule
    def calculateNewPrePostCoffeeWts(self,
                              semToCoffeeCorrelations,semToCokeCorrelations,
                              coffeeToSemCorrelations,cokeToSemCorrelations,
                              goalFromBeverageWt,goalFromSemWt):
        numSemNeurons = 50 # len (semToCoffeeCorrelations[0])
        numCoffeeNeurons = 100 # len (semToCoffeeCorrelations[0][0])
        numCokeNeurons = 100 # len (semToCokeCorrelations[0][0])

        #set up the total correlation to the coffeeTempNet 
        newSemToCoffeeWts =self.calculateNewPostAToBWts(semToCoffeeCorrelations,
                    numSemNeurons,numCoffeeNeurons,goalFromSemWt)

        #set up the total correlation to the cokeTempNet 
        newSemToCokeWts = self.calculateNewPostAToBWts(semToCokeCorrelations,
                    numSemNeurons,numCokeNeurons,goalFromSemWt)


        #Calculate from beverages
        newCoffeeToSemWts = self.calculateNewAToBWts(coffeeToSemCorrelations,
                        numCoffeeNeurons, numSemNeurons,goalFromBeverageWt)
        newCokeToSemWts = self.calculateNewAToBWts(cokeToSemCorrelations,
                        numCokeNeurons, numSemNeurons,goalFromBeverageWt)
                                                

        return [newSemToCoffeeWts,newSemToCokeWts,newCoffeeToSemWts,
                newCokeToSemWts]

    #Here we have three nets, the coffee, coke and semantic nets.
    #Calculate the new wts coffee <-> sem and coke <-> sem.
    def calculateNewPrePreCoffeeWts(self,
                              semToCoffeeCorrelations,semToCokeCorrelations,
                              coffeeToSemCorrelations,cokeToSemCorrelations,
                              goalFromBeverageWt,goalFromSemWt):
        numSemNeurons = 50 # len (semToCoffeeCorrelations[0])
        numCoffeeNeurons = 100 # len (semToCoffeeCorrelations[0][0])
        numCokeNeurons = 100 # len (semToCokeCorrelations[0][0])

        #set up the blank well connected matrices
        newSemToCoffeeWts = np.zeros((numSemNeurons,numCoffeeNeurons),dtype='f')
        newSemToCokeWts = np.zeros((numSemNeurons,numCokeNeurons),dtype='f')
    
        #set up the total correlation from the semantic net
        for preNeuron in range (0,numSemNeurons):
            totalCorrelation = 0.0  #this can be greater than 1

            #calculate total correlations from this neuron, to both nets
            for postNeuron in range (0,numCoffeeNeurons):
                totalCorrelation+=semToCoffeeCorrelations[preNeuron,postNeuron] 
            for postNeuron in range (0,numCokeNeurons):
                totalCorrelation+=semToCokeCorrelations[preNeuron,postNeuron] 

            #get this preNeurons correlation modifier
            preCorrMod = 0.0
            if (totalCorrelation > 0):
                preCorrMod = goalFromSemWt/totalCorrelation

            #Calculate the weiths from semantics
            for postNeuron in range (0,numCoffeeNeurons):
                newWt = semToCoffeeCorrelations[preNeuron,postNeuron]*preCorrMod
                newSemToCoffeeWts [preNeuron,postNeuron]  =  newWt 

            for postNeuron in range (0,numCokeNeurons):
                newWt = semToCokeCorrelations[preNeuron,postNeuron]*preCorrMod
                newSemToCokeWts [preNeuron,postNeuron]  =  newWt 

        #Calculate from beverages
        newCoffeeToSemWts = self.calculateNewAToBWts(coffeeToSemCorrelations,
                        numCoffeeNeurons, numSemNeurons,goalFromBeverageWt)
        newCokeToSemWts = self.calculateNewAToBWts(cokeToSemCorrelations,
                        numCokeNeurons, numSemNeurons,goalFromBeverageWt)
                                                

        return [newSemToCoffeeWts,newSemToCokeWts,newCoffeeToSemWts,
                newCokeToSemWts]
