#
#
#
import sys

import numpy as np
import pyNN.nest as sim
import cPickle as pickle
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from mergeClass import MergeBump

Duration = 15000

def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

def createTwoInputs():
	    inputSpikeTimes0 = [10.0]
	    inputSpikeTimes1 = [50.0]
	    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
	    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')
	    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
	    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
					   label='inputSpikes_1')

	    return [spikeGen0,spikeGen1]



#These connectMerge defs are for the connectivity to merge two distant streams 
#to two nearby streams.
def connectMergeAll(fromPop,toPop,numNeurons):
    weight = 0.0006
    connector = []
    for fromNeuron in range(0,numNeurons):
        for toNeuron in range(0,numNeurons):
            connector = connector + [(fromNeuron,toNeuron,weight, neal.DELAY)]

    neal.nealProjection(fromPop, toPop, connector, 'excitatory')


#--main
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    testType  = int(args[1])
else:
    testType = 2
print testType

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
mergeObject = MergeBump(neal,fsa)

init()

neurons = 100
cellClass=sim.IF_cond_exp
cellParams=fsa.CELL_PARAMS

#mergeObject.makeMergeBump(neurons,2,4,0.08,0.08,toOvercomeWt=0.0013,inhibOvercomeWt = 0.4) #the defaults
#mergeObject.makeMergeBump(neurons,2,4,0.08,0.08)) 
#mergeObject.makeMergeBump(neurons,2,4,0.09,0.09,toOvercomeWt=0.0013,inhibOvercomeWt = 0.3) #the defaults
#mergeObject.makeMergeBump(neurons,2,4,0.09,0.09)
mergeObject.makeMergeBump(neurons,2,4,0.07,0.07)
mergeObject.setupRecording()


#TEST  
spikeSource = createTwoInputs()
if testType == 1: 
    for inputTemp in range (10,13):
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 2: 
    for inputTemp in range (13,31):
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 3: 
    for inputTemp in range (0,10): #10
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 4: 
    for inputTemp in range (10,25): #15
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 5: 
    for inputTemp in range (0,25): #25
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 6: 
    for inputTemp in range (70,100): #30
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 7: 
    for inputTemp in range (25,70): #45
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)
elif testType == 8: 
    for inputTemp in range (25,100): #75
        mergeObject.turnOnCellFromSpikeSource(spikeSource[0],inputTemp)

else: print "No testType=", testType

neal.nealApplyProjections()
sim.run(Duration)
sim.end()

mergeObject.printResults("outputs/fm9T")



