#This is the overcome simulation.  For the data in the paper, call it with
#python overcome.py 9
#You then need printAllPklFile on both populations.
import sys

import numpy as np
import pyNN.nest as sim
import cPickle as pickle
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from stableBumpClass import StableBump

def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

#####
def connectPopToOvercome(fromPop,toPop):
    numNeurons = 100
    exciteConnector = []
    width = 10
    for fromNeuron in range(0,numNeurons):
        startTo = fromNeuron - width
        if (startTo < 0):
            startTo = 0
        endTo = fromNeuron+width+1
        if (endTo > (numNeurons-1)):
            endTo = numNeurons
        for toNeuron in range(startTo,endTo):
            weight = 0.0013#0.0012 #0.0015 0.001
            exciteConnector = exciteConnector + [(fromNeuron,toNeuron,weight, neal.DELAY)]
    neal.nealProjection(fromPop, toPop, exciteConnector, 'excitatory')

def connectOvercomeToPop(fromPop,toPop):
    numNeurons = 100
    exciteConnector = []
    width = 3
    for fromNeuron in range(0,numNeurons):
        #weight = 1.0
        #exciteConnector = exciteConnector + [(fromNeuron,fromNeuron,weight, neal.DELAY)]

        startTo = fromNeuron - width
        if (startTo < 0):
            startTo = 0
        endTo = fromNeuron+width+1
        if (endTo > (numNeurons-1)):
            endTo = numNeurons
        for toNeuron in range(startTo,endTo):
            weight = 0.2
            exciteConnector = exciteConnector + [(fromNeuron,toNeuron,weight, neal.DELAY)]
    #print exciteConnector
    neal.nealProjection(fromPop, toPop, exciteConnector, 'excitatory')

def connectInhibOvercomeToPop(fromPop,toPop):
    numNeurons = 100
    inhibitConnector = []
    width = 8
    endWidth = 4
    weight = 0.4 #0.3
    for fromNeuron in range(0,numNeurons):
        startTo = fromNeuron - width
        if (startTo < 0):
            startTo = 0
        endTo = fromNeuron - endWidth
        if (endTo < 0):
            endTo = 0
        for toNeuron in range(startTo,endTo):
            inhibitConnector = inhibitConnector + [(fromNeuron,toNeuron,weight, neal.DELAY)]

        startTo = fromNeuron + endWidth+1
        if (startTo > (numNeurons-1)):
            startTo = numNeurons
        endTo = fromNeuron + width+1
        if (endTo > (numNeurons-1)):
            endTo = numNeurons
        for toNeuron in range(startTo,endTo):
            inhibitConnector = inhibitConnector + [(fromNeuron,toNeuron,weight, neal.DELAY)]

    #print inhibitConnector
    neal.nealProjection(fromPop, toPop, inhibitConnector, 'inhibitory')



#--main
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    testType  = int(args[1])
else:
    testType = 2
print testType

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
stableBump = StableBump(neal,fsa)

init()

neurons = 100
cellClass=sim.IF_cond_exp
cellParams=fsa.CELL_PARAMS
tempPop = stableBump.stableBump(neurons,cellClass,cellParams,2,4,0.08,0.08)
tempPop.record(['spikes','v','gsyn_exc','gsyn_inh'])

overcomePop = sim.Population(neurons, sim.IF_cond_exp, 
                             fsa.CELL_PARAMS)
overcomePop.record(['spikes','v','gsyn_exc','gsyn_inh'])

#
connectPopToOvercome(tempPop,overcomePop)
connectOvercomeToPop(overcomePop,tempPop)
connectInhibOvercomeToPop(overcomePop,tempPop)

#TEST  
source0 = stableBump.createTwoInputs()
spikeSource = stableBump.createTwoInputs()
if testType == 1: 
    for inputTemp in range (10,13):
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 2: 
    for inputTemp in range (13,31):
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 3: 
    for inputTemp in range (0,10): #10
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 4: 
    for inputTemp in range (10,25): #15
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 5: 
    for inputTemp in range (0,25): #25
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 6: 
    for inputTemp in range (70,100): #30
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 7: 
    for inputTemp in range (25,70): #45
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 8: 
    for inputTemp in range (25,100): #75
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)
elif testType == 9: 
    for inputTemp in range (10,24): #14
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)

else: print "No testType=", testType

neal.nealApplyProjections()
sim.run(1000)
sim.end()

tempPopPkl = tempPop.write_data("paperData/popTempO.pkl")
tempPop.print_v("paperData/popTempOV.pkl")
#tempPop.write_data("paperData/popTempE.pkl",'gsyn_exc')
#tempPop.write_data("paperData/popTempI.pkl",'gsyn_inh')
overcomePop.write_data("paperData/overcomePop.pkl")
overcomePop.print_v("paperData/overcomePopV.pkl")
#overcomePop.write_data("paperData/overcomePopE.pkl",'gsyn_exc')
#overcomePop.write_data("paperData/overcomePopI.pkl",'gsyn_inh')

