# This is the simple associative memory that we use in the paper. 
#
#
#
#
import pyNN.nest as sim
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from hotCoffeeTopologyClass import HotCoffeeClass

#a bit cheeky.  Should get them from hotCoffeeClass
COFFEE = 0
COKE = 1
COLD = 2
WARM = 3
HOT = 4

def create18InputsAndStop():
    inputSpikeTimes0 = [25.0] #on
    inputSpikeTimes1 = [325.0] 
    inputSpikeTimes2 = [625.0]
    inputSpikeTimes3 = [925.0]
    inputSpikeTimes4 = [1225.0]
    inputSpikeTimes5 = [1525.0] 
    inputSpikeTimes6 = [1825.0]
    inputSpikeTimes7 = [2125.0]
    inputSpikeTimes8 = [2425.0]
    inputSpikeTimes9 = [2725.0]
    inputSpikeTimes10 = [3025.0]
    inputSpikeTimes11 = [3325.0] 
    inputSpikeTimes12 = [3625.0]
    inputSpikeTimes13 = [3925.0] 
    inputSpikeTimes14 = [4225.0] 
    inputSpikeTimes15 = [4525.0] 
    inputSpikeTimes16 = [4825.0] 
    inputSpikeTimes17 = [5125.0] 
	    
    stopSpikeTimes = [300.0,600.0,900.0,1200.0,1500.0,1800.0,2100.0,2400.0,2700.0,3000.0,3300.0,3600.0,3900.0,4200.0,4500.0,4800.0, 5100.0, 5400.0]
	    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
					   label='inputSpikes_1')
    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeGen2=sim.Population(1,sim.SpikeSourceArray,spikeArray2,
					   label='inputSpikes_2')

    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    spikeGen3=sim.Population(1,sim.SpikeSourceArray,spikeArray3,
					   label='inputSpikes_3')
    spikeArray4 = {'spike_times': [inputSpikeTimes4]}
    spikeGen4=sim.Population(1,sim.SpikeSourceArray,spikeArray4,
					   label='inputSpikes_4')
    spikeArray5 = {'spike_times': [inputSpikeTimes5]}
    spikeGen5=sim.Population(1,sim.SpikeSourceArray,spikeArray5,
					   label='inputSpikes_5')

    spikeArray6 = {'spike_times': [inputSpikeTimes6]}
    spikeGen6=sim.Population(1,sim.SpikeSourceArray,spikeArray6,
					   label='inputSpikes_6')
    spikeArray7 = {'spike_times': [inputSpikeTimes7]}
    spikeGen7=sim.Population(1,sim.SpikeSourceArray,spikeArray7,
					   label='inputSpikes_7')
    spikeArray8 = {'spike_times': [inputSpikeTimes8]}
    spikeGen8=sim.Population(1,sim.SpikeSourceArray,spikeArray8,
					   label='inputSpikes_8')

    spikeArray9 = {'spike_times': [inputSpikeTimes9]}
    spikeGen9=sim.Population(1,sim.SpikeSourceArray,spikeArray9,
					   label='inputSpikes_9')
    spikeArray10 = {'spike_times': [inputSpikeTimes10]}
    spikeGen10=sim.Population(1,sim.SpikeSourceArray,spikeArray10,
					   label='inputSpikes_10')
    spikeArray11 = {'spike_times': [inputSpikeTimes11]}
    spikeGen11=sim.Population(1,sim.SpikeSourceArray,spikeArray11,
					   label='inputSpikes_11')

    spikeArray12 = {'spike_times': [inputSpikeTimes12]}
    spikeGen12=sim.Population(1,sim.SpikeSourceArray,spikeArray12,
					   label='inputSpikes_12')
    spikeArray13 = {'spike_times': [inputSpikeTimes13]}
    spikeGen13=sim.Population(1,sim.SpikeSourceArray,spikeArray13,
					   label='inputSpikes_13')
    spikeArray14 = {'spike_times': [inputSpikeTimes14]}
    spikeGen14=sim.Population(1,sim.SpikeSourceArray,spikeArray14,
					   label='inputSpikes_14')

    spikeArray15 = {'spike_times': [inputSpikeTimes15]}
    spikeGen15=sim.Population(1,sim.SpikeSourceArray,spikeArray15,
					   label='inputSpikes_15')
    spikeArray16 = {'spike_times': [inputSpikeTimes16]}
    spikeGen16=sim.Population(1,sim.SpikeSourceArray,spikeArray16,
					   label='inputSpikes_16')
    spikeArray17 = {'spike_times': [inputSpikeTimes17]}
    spikeGen17=sim.Population(1,sim.SpikeSourceArray,spikeArray17,
					   label='inputSpikes_17')


    stopSpikeArray= {'spike_times': [stopSpikeTimes]}
    stopSpikeGen=sim.Population(1,sim.SpikeSourceArray,stopSpikeArray,
					   label='stopSpikes')
	    
    return[spikeGen0,spikeGen1,spikeGen2,spikeGen3,spikeGen4,spikeGen5,spikeGen6,spikeGen7,spikeGen8,spikeGen9,spikeGen10,spikeGen11,spikeGen12,spikeGen13,spikeGen14,spikeGen15,spikeGen16,spikeGen17,stopSpikeGen]


#--main
#Make weights for plastic synapses 0.01 because that's what we're going
#to change.
#Present an example of all 6 types of triples.
#replace stableBump.createTwoInputs with a createSevenInputs in this file.
#One will start the first triple at 25, the second will start the second
#triple at 325 ... and the sixth will start the sixth triple at 1525
#The seventh stops everything at 300,600,900,1200,1500, and 1800.

#Then pass it through the count.
#Write another py file that uses the new "plastic weights", instead of
#the 0.01 weights.  Then test that with doubles (hot coffee, coffee 85deg)b

#args = sys.argv
Duration = 5500 

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
hotCoffeeTopology = HotCoffeeClass(simName,sim,neal,fsa,spinnVersion)

hotCoffeeTopology.makeHotCoffeeTopology()
hotCoffeeTopology.buildHotCoffeeTopology()
hotCoffeeTopology.connectTempsToSemanticBeverages()
hotCoffeeTopology.readSemanticTempsToTemps()

pop = hotCoffeeTopology.getSemanticsNeurons()
inputPop = hotCoffeeTopology.getTemperatureBumpNeurons()

#TEST 
spikeSource = create18InputsAndStop()
inhWeight = 2.5

hotCoffeeTopology.stopFullTopologyFromSpikeSource(spikeSource[18],inhWeight)

fsa.turnOnStateFromSpikeSource(spikeSource[0],pop, COFFEE)
for inputTemp in range(15,18): #cold range(0,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[0],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[1],pop, COLD)
for inputTemp in range(15,18): #cold range(0,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[1],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[2],pop, COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[2],pop, COLD)


fsa.turnOnStateFromSpikeSource(spikeSource[3],pop,COFFEE)
for inputTemp in range(40,43): #warm coffee range(25,69)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[3],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[4],pop,WARM)
for inputTemp in range(40,43): #warm coffee range(25,69)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[4],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[5],pop,COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[5],pop,WARM)

fsa.turnOnStateFromSpikeSource(spikeSource[6],pop,COFFEE)
for inputTemp in range(80,83): #hot coffee range(70,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[6],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[7],pop,HOT)
for inputTemp in range(80,83): #hot coffee range(70,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[7],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[8],pop,COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[8],pop,HOT)

fsa.turnOnStateFromSpikeSource(spikeSource[9],pop,COKE)
for inputTemp in range(4,7): #cold coke range(0,9)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[9],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[10],pop,COLD)
for inputTemp in range(4,7): #cold coke range(0,9)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[10],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[11],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[11],pop,COLD)

fsa.turnOnStateFromSpikeSource(spikeSource[12],pop,COKE)
for inputTemp in range(15,18): #warm coke range(10,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[12],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[13],pop,WARM)
for inputTemp in range(15,18): #warm coke range(10,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[13],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[14],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[14],pop,WARM)

fsa.turnOnStateFromSpikeSource(spikeSource[15],pop,COKE)
for inputTemp in range(40,43): #hot coke range(25,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[15],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[16],pop,HOT)
for inputTemp in range(40,43): #hot coke range(25,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[16],inputPop,inputTemp)
fsa.turnOnStateFromSpikeSource(spikeSource[17],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[17],pop,HOT)

neal.nealApplyProjections()
sim.run(Duration)
sim.end()

hotCoffeeTopology.printTopologySpikes("paperData/plastic/sixTest")
