# This is the simple associative memory that we use in the paper. 
#
#
#
#
import pyNN.nest as sim
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from hotCoffeeTopologyClass import HotCoffeeClass

#a bit cheeky.  Should get them from hotCoffeeClass
COFFEE = 0
COKE = 1
COLD = 2
WARM = 3
HOT = 4

def createSixInputsAndStop():
    inputSpikeTimes0 = [25.0] #on
    inputSpikeTimes1 = [325.0] 
    inputSpikeTimes2 = [625.0]
    inputSpikeTimes3 = [925.0]
    inputSpikeTimes4 = [1225.0]
    inputSpikeTimes5 = [1525.0]
	    
    stopSpikeTimes = [300.0,600.0,900.0,1200.0,1500.0,1800.0,2100.0,2400.0,2700.0,3000.0,3300.0]
	    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')

    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
					   label='inputSpikes_1')

    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
    spikeGen2=sim.Population(1,sim.SpikeSourceArray,spikeArray2,
					   label='inputSpikes_2')

    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
    spikeGen3=sim.Population(1,sim.SpikeSourceArray,spikeArray3,
					   label='inputSpikes_3')

    spikeArray4 = {'spike_times': [inputSpikeTimes4]}
    spikeGen4=sim.Population(1,sim.SpikeSourceArray,spikeArray4,
					   label='inputSpikes_4')

    spikeArray5 = {'spike_times': [inputSpikeTimes5]}
    spikeGen5=sim.Population(1,sim.SpikeSourceArray,spikeArray5,
					   label='inputSpikes_5')

    stopSpikeArray= {'spike_times': [stopSpikeTimes]}
    stopSpikeGen=sim.Population(1,sim.SpikeSourceArray,stopSpikeArray,
					   label='stopSpikes')
	    
    return[spikeGen0,spikeGen1,spikeGen2,spikeGen3,spikeGen4,spikeGen5,stopSpikeGen]



#--main
#Make weights for plastic synapses 0.01 because that's what we're going
#to change.
#Present an example of all 6 types of triples.
#replace stableBump.createTwoInputs with a createSevenInputs in this file.
#One will start the first triple at 25, the second will start the second
#triple at 325 ... and the sixth will start the sixth triple at 1525
#The seventh stops everything at 300,600,900,1200,1500, and 1800.

#Then pass it through the count.
#Write another py file that uses the new "plastic weights", instead of
#the 0.01 weights.  Then test that with doubles (hot coffee, coffee 85deg)b

#args = sys.argv
Duration = 2500 #this is changed for longer runs for merging streams

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
hotCoffeeTopology = HotCoffeeClass(simName,sim,neal,fsa,spinnVersion)

hotCoffeeTopology.makeHotCoffeeTopology()
hotCoffeeTopology.buildHotCoffeeTopology()
hotCoffeeTopology.connectTempsToSemanticBeverages()

pop = hotCoffeeTopology.getSemanticsNeurons()
inputPop = hotCoffeeTopology.getTemperatureBumpNeurons()

#TEST 
spikeSource = createSixInputsAndStop()
inhWeight = 2.5

hotCoffeeTopology.stopFullTopologyFromSpikeSource(spikeSource[6],inhWeight)

fsa.turnOnStateFromSpikeSource(spikeSource[0],pop, COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[0],pop, COLD)
for inputTemp in range(15,18): #cold range(0,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[0],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[1],pop,COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[1],pop,WARM)
for inputTemp in range(40,43): #warm coffee range(25,69)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[1],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[2],pop,COFFEE)
fsa.turnOnStateFromSpikeSource(spikeSource[2],pop,HOT)
for inputTemp in range(80,83): #hot coffee range(70,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[2],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[3],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[3],pop,COLD)
for inputTemp in range(4,7): #cold coke range(0,9)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[3],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[4],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[4],pop,WARM)
for inputTemp in range(15,18): #warm coke range(10,24)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[4],inputPop,inputTemp)

fsa.turnOnStateFromSpikeSource(spikeSource[5],pop,COKE)
fsa.turnOnStateFromSpikeSource(spikeSource[5],pop,HOT)
for inputTemp in range(40,43): #hot coke range(25,99)
	fsa.turnOnOneNeuronFromSpikeSource(spikeSource[5],inputPop,inputTemp)

neal.nealApplyProjections()
sim.run(Duration)
sim.end()

hotCoffeeTopology.printTopologySpikes("outputs/chris")
