# Stable Bump Class
#
#
import cPickle as pickle
import pyNN.nest as sim
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
import numpy as np
import sys

class StableBump:
	def __init__(self,NEAL,FSA):
		simName = "nest"
		spinnVersion = -1
		self.neal = NEAL
		self.fsa = FSA
	
        def makeStableBumpConnections(self,numNeurons,neurons,excitatoryWindow, 
                               inhibitoryWindow,exciteWeight,inhibWeight):
            exciteConnector = []
            inhibConnector = []

            for fromNeuron in range (0,numNeurons):
                longExciteWeight = 0.0 #0.02
                #exciteWeight = 0.1 #0.08
                #inhibWeight = 0.01 #0.08

                #before excite
                beforeExcite = fromNeuron-excitatoryWindow
                if (beforeExcite < 0): beforeExcite = 0
                for toNeuron in range(beforeExcite,fromNeuron):
                    exciteConnector = exciteConnector + [(fromNeuron,toNeuron,
                                        exciteWeight, self.neal.DELAY)]

                #after excite
                afterExcite = fromNeuron+excitatoryWindow+1
                if (afterExcite > numNeurons): afterExcite = numNeurons
                for toNeuron in range(fromNeuron+1,afterExcite):
                    exciteConnector = exciteConnector + [(fromNeuron,toNeuron,
                                        exciteWeight, self.neal.DELAY)]

                """
                #long excite 
                beforeExcite = toNeuron - (excitatoryWindow+inhibitoryWindow+6)
                if (beforeExcite >=0):
                        exciteConnector = exciteConnector+ [(fromNeuron,
                                beforeExcite,longExciteWeight, self.neal.DELAY)]
                afterExcite = toNeuron + (excitatoryWindow+inhibitoryWindow+6)
                if (afterExcite < numNeurons):
                        exciteConnector = exciteConnector+ [(fromNeuron,
                                afterExcite,longExciteWeight, self.neal.DELAY)]
                """

                #before inhib
                beforeInhibStart=fromNeuron-(excitatoryWindow+inhibitoryWindow)
                beforeInhibEnd=fromNeuron-(excitatoryWindow)
                if (beforeInhibStart < 0): beforeInhibStart = 0
                for toNeuron in range(beforeInhibStart,beforeInhibEnd):
                    inhibConnector = inhibConnector + [(fromNeuron,toNeuron,
                                        inhibWeight, self.neal.DELAY)]


                #after inhib
                afterInhibStart=fromNeuron+excitatoryWindow+1
                afterInhibEnd=fromNeuron+excitatoryWindow+inhibitoryWindow+1
                if (afterInhibEnd > numNeurons): afterInhibEnd = numNeurons
                for toNeuron in range(afterInhibStart,afterInhibEnd):
                    inhibConnector = inhibConnector + [(fromNeuron,toNeuron,
                                        inhibWeight, self.neal.DELAY)]

            #end from loop
            
            #print exciteConnector
            self.neal.nealProjection(neurons, neurons, exciteConnector,
                                         'excitatory')
            #print 'inhib',inhibConnector
            self.neal.nealProjection(neurons, neurons,inhibConnector,
                                         'inhibitory')

	
	def stableBump(self, numNeurons,cellclass,cellparams,exWindow,inWindow,
                exWeight,inhibWeight):

                excitatoryWindow = exWindow
                inhibitoryWindow = inWindow
		neurons = sim.Population(numNeurons, cellclass, cellparams)
                self.makeStableBumpConnections(numNeurons,neurons,
                        excitatoryWindow,inhibitoryWindow,exWeight,inhibWeight)
                return neurons
                                        
	def turnOnWindowFromSpikeSource(self,spikeSource,temp,tempID):
		conn = [(0,tempID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
		connector = sim.FromListConnector(conn)
		projections = sim.Projection(spikeSource, temp, 
			connector, 
			sim.StaticSynapse(weight=0.5),
			'excitatory')
		return projections

	def turnOffWindowFromSpikeSource(self,spikeSource,temp,tempID):
		conn = [(0,tempID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
		connector = sim.FromListConnector(conn)
		projections = sim.Projection(spikeSource, temp, 
			connector, 
			sim.StaticSynapse(weight=0.5),
			'inhibitory')
		return projections


	
	def createTwoInputs(self):
	    inputSpikeTimes0 = [10.0]
	    inputSpikeTimes1 = [50.0]
	    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
	    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')
	    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
	    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
					   label='inputSpikes_1')

	    return [spikeGen0,spikeGen1]
	
	def createThreeInputs(self):
	    inputSpikeTimes0 = [10.0]
	    inputSpikeTimes1 = [25.0]
	    inputSpikeTimes2 = [50.0]
	    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
	    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')
	    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
	    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
					   label='inputSpikes_1')

	    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
	    spikeGen2=sim.Population(1, sim.SpikeSourceArray, spikeArray2,
					   label='inputSpikes_2')
	    return [spikeGen0,spikeGen1,spikeGen2]

	def createMultiInputs(self):
	    inputSpikeTimes0 = [25.0] #on
	    inputSpikeTimes1 = [325.0] 
	    inputSpikeTimes2 = [625.0]
	    inputSpikeTimes3 = [925.0]
	    inputSpikeTimes4 = [1225.0]
	    inputSpikeTimes5 = [1525.0]
	    
	    stopSpikeTimes = [300.0,600.0,900.0,1200.0,1500.0,1800.0,2100.0,2400.0,2700.0,3000.0,3300.0]
	    
	    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
	    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')

	    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
	    spikeGen1=sim.Population(1,sim.SpikeSourceArray,spikeArray1,
					   label='inputSpikes_1')

	    spikeArray2 = {'spike_times': [inputSpikeTimes2]}
	    spikeGen2=sim.Population(1,sim.SpikeSourceArray,spikeArray2,
					   label='inputSpikes_2')

	    spikeArray3 = {'spike_times': [inputSpikeTimes3]}
	    spikeGen3=sim.Population(1,sim.SpikeSourceArray,spikeArray3,
					   label='inputSpikes_3')

	    spikeArray4 = {'spike_times': [inputSpikeTimes4]}
	    spikeGen4=sim.Population(1,sim.SpikeSourceArray,spikeArray4,
					   label='inputSpikes_4')

	    spikeArray5 = {'spike_times': [inputSpikeTimes5]}
	    spikeGen5=sim.Population(1,sim.SpikeSourceArray,spikeArray5,
					   label='inputSpikes_5')

            stopSpikeArray= {'spike_times': [stopSpikeTimes]}
	    stopSpikeGen=sim.Population(1,sim.SpikeSourceArray,stopSpikeArray,
					   label='stopSpikes')
	    
	    return[spikeGen0,spikeGen1,spikeGen2,spikeGen3,spikeGen4,spikeGen5,stopSpikeGen]

        def createMultiInputsLearn(self,Tin,step,startDelay,Tend):
            stopSpikeTimes = range(startDelay,Tend,step)
            stopSpikeGen = sim.Population(1,sim.SpikeSourceArray,{'spike_times' : stopSpikeTimes},label="stopSpikes")
            startSpikeTimes = []
	    startSpikeTimesMatrix = []
            for spikeNumber in range(Tin,Tend,step):
		startSpikeTime = spikeNumber
	        startSpikeTimes = [startSpikeTime]
		startSpikeTimesMatrix = startSpikeTimesMatrix + [startSpikeTimes]
	    startSpikeGen = sim.Population(Tend/step,sim.SpikeSourceArray,{'spike_times': startSpikeTimesMatrix},label="startSpikes")
            return [startSpikeGen, stopSpikeGen]


	def printResults(self, simCells):
	    simCells.printSpikes('temp.pkl')

	def setupRecording(self, cells):
	    cells.record({'spikes','v'})

	def turnOnCellFromSpikeSource(self,spikeSource,pop,cellID):
		connector = [(0,cellID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
	        self.neal.nealProjection(spikeSource,pop,connector,'excitatory')
	
        def turnOnCellFromMultiSpikeSources(self,spikeSource,pop,cellID,sourceID):
		connector = [(sourceID,cellID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
	        self.neal.nealProjection(spikeSource,pop,connector,'excitatory')
		return connector

	def turnOffCellFromSpikeSource(self,spikeSource,pop,cellID):
		connector = [(0,cellID,self.fsa.INPUT_WEIGHT,self.neal.DELAY)]
	        self.neal.nealProjection(spikeSource,pop,connector,'inhibitory')
	
	def inhibitCellFromSpikeSource(self,spikeSource,pop,cellID,inhWeight):
		connector = [(0,cellID,inhWeight,self.neal.DELAY)]
	        self.neal.nealProjection(spikeSource,pop,connector,'inhibitory')
		return connector
	
	def stateHalfTurnsOnCell(self,fromNeurons,fromCA,pop,cellID):
		connector = []
        	#uses HALF_ON_WEIGHT
        	for fromOffset in range (0,self.fsa.CA_SIZE-self.fsa.CA_INHIBS):
            		fromNeuron = fromOffset + (fromCA*self.fsa.CA_SIZE)
            		connector=connector+[(fromNeuron,cellID,
				self.fsa.HALF_ON_WEIGHT,
                        	self.neal.DELAY)]

	        self.neal.nealProjection(fromNeurons,pop,connector,'excitatory')
