# This is a test of the stable bump.  
# Call it like 
# python stableBumpTest.py 3 0.08 0.08
# python stableBumpTest.py Inputs Ex Inh
# where inputs is the number of inputs; Ex the excitatory weights, and Inh
# the inhibitory weights.

import sys

import numpy as np
import pyNN.nest as sim
import cPickle as pickle
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from stableBumpClass import StableBump

#
def init():
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)

#--main
args = sys.argv
Duration = 300  #this is changed for longer runs for merging streams
numberArgs = args.__len__()
if (numberArgs == 4):
    inputs  = int(args[1])
    exciteWt  = float(args[2])
    inhibWt  = float(args[3])
else:
    inputs = 3
    exciteWt = 0.08
    inhibWt = 0.08

print inputs, exciteWt, inhibWt,numberArgs

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
stableBump = StableBump(neal,fsa)

init()

neurons = 100
cellClass=sim.IF_cond_exp
cellParams=fsa.CELL_PARAMS
#tempPop = stableBump.stableBump(neurons,cellClass,cellParams,2,4,0.08,0.08)
tempPop = stableBump.stableBump(neurons,cellClass,cellParams,2,4,exciteWt,inhibWt)
tempPop.record(['spikes','v','gsyn_exc','gsyn_inh'])

#TEST 
spikeSource = stableBump.createTwoInputs()
for inputTemp in range (10,10 + inputs):
        stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,inputTemp)


neal.nealApplyProjections()
sim.run(300)
sim.end()

tempPopPkl = tempPop.write_data("paperData/popTemp.pkl")
#tempPop.print_v("paperData/popTempV.pkl")
#tempPop.write_data("paperData/popTempE.pkl",'gsyn_exc')
#tempPop.write_data("paperData/popTempI.pkl",'gsyn_inh')


