#This should count the cofires and nonCofires of neurons.
#It works on the three networks, coffeeTemp, cokeTemp and 

#It writes the synaptic weights to files.
#Cofiring is at the same time or with the postSynaptic neuron firing after
#but with the preTime + coFireWindow.

#tests are pretty weak

import sys
import numpy as np
from countCofireClass import CountCoFireClass

#constants
dirName = "inputs/"
compensatoryWt = 0.01

#this is for two sets of correlations from firstToC and fromSecondtoC
def calculateCorrelationAndMakeWts(firstPairCoRs,secondPairCoRs,firstFileName,
                                secondFileName):
    neuronsInFirst = len(firstPairCoRs[0][0])
    neuronsInSecond = len(secondPairCoRs[0][0])
    neuronsInC = len(firstPairCoRs[0])
    #print neuronsInFirst,neuronsInSecond,neuronsInC
    firstToCCorrelation = cofireCounter.calculateCorrelation(firstPairCoRs[0],
                                firstPairCoRs[1],neuronsInC,neuronsInFirst)
    secondToCCorrelation = cofireCounter.calculateCorrelation(secondPairCoRs[0],
                                secondPairCoRs[1],neuronsInC,neuronsInSecond)

    """
    np.savetxt('results/VtoVCorr.txt',verbToVCorrelation,"%s")
    np.savetxt('results/VtoNCorr.txt',verbToNCorrelation,"%s")
    """

    newWts = cofireCounter.calculateNewPreWtsFromToTwo(firstToCCorrelation,
                        secondToCCorrelation,compensatoryWt)
    firstFileName = dirName+firstFileName+ "Wts.txt"
    secondFileName = dirName+secondFileName+ "Wts.txt"
    np.savetxt(firstFileName,newWts[0],"%s")
    np.savetxt(secondFileName,newWts[1],"%s")

def calcAllWeights(semToCoffeeCofires, semToCokeCofires,
                   coffeeToSemCofires,cokeToSemCofires):

    numSemNeurons = 50 # len (semToCoffeeCofires[0])
    numCoffeeNeurons = 100 # len (semToCoffeeCofires[0][0])
    numCokeNeurons = 100 # len (semToCokeCofires[0][0])

    #print "semtToCoffee", len (semToCoffeeCofires)
    #print "semtToCoffee", semToCoffeeCofires[0]
    #print "semtToCoffee", semToCoffeeCofires[1] #noFires

    semToCoffeeCorrelations = cofireCounter.calculateCorrelation(
        semToCoffeeCofires[0],semToCoffeeCofires[1],numSemNeurons,
        numCokeNeurons)
    semToCokeCorrelations = cofireCounter.calculateCorrelation(
        semToCokeCofires[0],semToCokeCofires[1],numSemNeurons,
        numCokeNeurons)
    coffeeToSemCorrelations = cofireCounter.calculateCorrelation(
        coffeeToSemCofires[0],coffeeToSemCofires[1],numCoffeeNeurons,
        numSemNeurons)
    cokeToSemCorrelations = cofireCounter.calculateCorrelation(
        cokeToSemCofires[0],cokeToSemCofires[1],numCokeNeurons,
        numSemNeurons)

    newWts = cofireCounter.calculateNewPrePostCoffeeWts(semToCoffeeCorrelations,
        semToCokeCorrelations,coffeeToSemCorrelations, cokeToSemCorrelations,
                                                        0.03,0.1)
#                                                        0.03,0.05)
    return newWts


#--main 
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    fileName = args[1]
else:
    fileName = "inputs/"


coffeeTempFileName = fileName + "-coffeeTempStable.pkl"
cokeTempFileName = fileName + "-cokeTempStable.pkl"
semFileName = fileName + "-semPop.pkl"
#semToCokeFileName = fileName + "semToCoke.txt"

cofireCounter = CountCoFireClass()

coffeeSpikeTrains = cofireCounter.getSpikes(coffeeTempFileName)
cokeSpikeTrains = cofireCounter.getSpikes(cokeTempFileName)
semanticsSpikeTrains = cofireCounter.getSpikes(semFileName)

semToCoffeeCofires = cofireCounter.countPreCorrTwoNets(semanticsSpikeTrains,
                                                   coffeeSpikeTrains)
coffeeToSemCofires = cofireCounter.countPreCorrTwoNets(coffeeSpikeTrains,
                                                   semanticsSpikeTrains)

semToCokeCofires = cofireCounter.countPreCorrTwoNets(semanticsSpikeTrains,
                                                   cokeSpikeTrains)
cokeToSemCofires = cofireCounter.countPreCorrTwoNets(cokeSpikeTrains,
                                                   semanticsSpikeTrains)

#np.savetxt('results/semCoffee.txt',semToCoffeeCofires[0],"%s")
#np.savetxt('results/coffeeSem.txt',coffeeToSemCofires[0],"%s")
#np.savetxt('results/semCoke.txt',semToCokeCofires[0],"%s")
#np.savetxt('results/cokeSem.txt',cokeToSemCofires[0],"%s")

wts = calcAllWeights(semToCoffeeCofires, semToCokeCofires,coffeeToSemCofires,
               cokeToSemCofires)

np.savetxt('results/coffeeSemWts.txt',wts[0],"%s")
np.savetxt('results/cokeSemWts.txt',wts[1],"%s")
np.savetxt('results/semCoffeeWts.txt',wts[2],"%s")
np.savetxt('results/semCokeWts.txt',wts[3],"%s")


